<script setup lang="ts">
    import { useMsal } from '@/plugins/msal/useMsal'
    import { computed, Ref, ref } from 'vue'
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import { SiilabConfiguration } from '../../entities/siilabConfiguration/SiilabConfiguration'
    import { SiilabConfigurationApi } from '../../entities/siilabConfiguration/SiilabConfigurationApi'
    import RouteNavigationDrawer from '@/shared/administration/components/RouteNavigationDrawer.vue'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { useSiilabConfigurationStore } from '@/shared/administration/stores/SiilabConfigurationStore'
    import { isDefined, isUndefined } from '@/shared/helpers/types'
    import { watchEffect } from 'vue'

    const msal = useMsal()

    const siilabConfigurationApi = new SiilabConfigurationApi(msal)
    const siilabConfigurationStore = useSiilabConfigurationStore()
    const editableSiilabConfiguration: Ref<SiilabConfiguration | undefined> =
        ref(siilabConfigurationStore.siilabConfiguration)

    watchEffect(() => {
        if (isDefined(siilabConfigurationStore.siilabConfiguration)) {
            editableSiilabConfiguration.value =
                siilabConfigurationStore.siilabConfiguration.clone()
        }
    })

    const formIsValid = ref<boolean>(false)

    const mapCenterLatitudeStringToNumber = computed({
        get() {
            return editableSiilabConfiguration.value?.mapCenterLatitude
        },
        set(latitude) {
            if (editableSiilabConfiguration.value) {
                editableSiilabConfiguration.value.mapCenterLatitude =
                    Number(latitude)
            }
        },
    })
    const mapCenterLongitudeStringToNumber = computed({
        get() {
            return editableSiilabConfiguration.value?.mapCenterLongitude
        },
        set(longitude) {
            if (editableSiilabConfiguration.value) {
                editableSiilabConfiguration.value.mapCenterLongitude =
                    Number(longitude)
            }
        },
    })
</script>

<template>
    <route-navigation-drawer page-title="Général" />
    <v-main>
        <s-content-container>
            <div class="py-3">
                <h3>Position par défaut des cartes</h3>
                <p class="text-subtitle-1">
                    Cette position est utilisée pour centrer les cartes quand
                    ils n'y à pas d'élements géolocalisés à afficher (ex.
                    pendant le chargement des interventions).
                </p>
            </div>
            <v-skeleton-loader
                v-if="isUndefined(editableSiilabConfiguration)"
                type="heading, heading, heading, actions"
            ></v-skeleton-loader>
            <v-form
                v-else
                v-model="formIsValid"
                @submit.prevent="
                    () => {
                        siilabConfigurationStore.siilabConfiguration =
                            editableSiilabConfiguration
                        siilabConfigurationStore.persist()
                    }
                "
            >
                <v-row>
                    <v-col cols="12" data-cy="global-latitude-map">
                        <v-text-field
                            v-model="mapCenterLatitudeStringToNumber"
                            type="number"
                            label="Latitude des cartes"
                            class="mb-3"
                            step="0.000001"
                            hide-details="auto"
                        ></v-text-field>
                    </v-col>
                    <v-col cols="12" data-cy="global-longitude-map">
                        <v-text-field
                            v-model="mapCenterLongitudeStringToNumber"
                            type="number"
                            label="Longitude des cartes"
                            class="mb-3"
                            step="0.000001"
                            hide-details="auto"
                        ></v-text-field
                    ></v-col>
                </v-row>

                <p class="text-right">
                    <s-action-button
                        icon="mdi-check"
                        label="Enregistrer"
                        :disabled="!formIsValid"
                        :loading="siilabConfigurationApi.isProcessing.value"
                        type="submit"
                        data-cy="submit"
                    >
                    </s-action-button>
                </p>
            </v-form>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
